# Copyright (C) 2009 Martin Albisetti

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""Coordinates logging of all demonized services for this application"""

# standard library imports
import os
import logging
from logging import handlers
# related 3rd party imports

# local application/ library specific imports.

# logging
log = logging.getLogger("bark")
try:
    home = os.path.expanduser('~')
    console_handler = handlers.RotatingFileHandler(
            os.path.join(home, ".backupark.log"), "a", "2048", 5)
except IOError:
    console_handler = logging.StreamHandler()
console_handler.setFormatter(logging.Formatter("""%(asctime)s - %(levelname)s:
%(message)s %(module)s %(funcName)s %(lineno)d """))
log.addHandler(console_handler)
log.setLevel(20)
