#! /usr/bin/env python2.5
# Copyright (C) 2008 Martin Albisetti 

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


"""Testing rdiff_backup.librsync"""

# standard library imports
import unittest
import os
import os.path
import sys
import shutil
import itertools
# related 3rd party imports
from rdiff_backup import librsync as l
from rdiff_backup import Rdiff as R
from rdiff_backup import rpath as r
from rdiff_backup import Globals as G
# local application/ library specific imports.
sys.path.insert(1,sys.path[0].rsplit('/',1)[0])

files = ["test/dummy/binary1.bin", "test/dummy/binary2.bin", 
         "test/dummy/binary3.bin"]

class testError(Exception):
    pass

class testLibrsync(unittest.TestCase):

    #def setUp(self):
    #    """Deleting files, dirs and recreating them"""
    #    if not itertools.ifilterfalse(os.path.exists, files):
    #        raise testError("""You need binary1.bin, binary2.bin and \
#binary3.bin in the dummy subdir""")
    #    # we backup :) binary1.bin
    #    shutil.copyfile("test/dummy/binary1.bin", "test/dummy/binary0.bin")

    #def tearDown(self):
    #    """Taking all back"""
    #    shutil.copyfile("test/dummy/binary0.bin", "test/dummy/binary1.bin")
    #    os.remove("test/dummy/binary0.bin")

    def testLib1(self):
        """Patch just one increment"""
        a = open("test/dummy/binary2.bin", 'rb')
        b = open("test/dummy/test1.sig", 'wb')
        bs = R.find_blocksize(os.path.getsize("test/dummy/binary2.bin"))
        x = l.SigFile(a, bs)
        while 1:
            buf = x.read(G.blocksize)
            if not buf: break
            b.write(buf)
        b.close()
        x.close()
        
        #shutil.copyfile("test/dummy/binary2.bin", "test/dummy/binary1.bin")
        
        a = open("test/dummy/binary1.bin", 'rb')
        b = open("test/dummy/test1.sig", 'rb')
        c = open("test/dummy/test1.del", 'wb')
        str = ""
        y = l.DeltaFile(l.SigFile(open("test/dummy/binary2.bin", 'rb'), 
        R.find_blocksize(os.path.getsize("test/dummy/binary2.bin"))), a)
        while not y.eof:
            str += y.read(G.blocksize)
        c.write(str)
        c.close()
        y.close()

        a = open("test/dummy/binary3.bin", 'rb')
        b = open("test/dummy/test2.sig", 'wb')
        x = l.SigFile(a, bs)
        while 1:
            buf = x.read(G.blocksize)
            if not buf: break
            b.write(buf)
        b.close()
        x.close()

        #shutil.copyfile("test/dummy/binary3.bin", "test/dummy/binary1.bin")
        
        a = open("test/dummy/binary2.bin", 'rb')
        b = open("test/dummy/test2.sig", 'rb')
        c = open("test/dummy/test2.del", 'wb')
        y = l.DeltaFile(l.SigFile(open("test/dummy/binary3.bin", 'rb'), 
        R.find_blocksize(os.path.getsize("test/dummy/binary3.bin"))), a)
        while 1:
            buf = y.read(G.blocksize)
            if not buf: break
            c.write(buf)
        c.close()
        y.close()

def SuiteRB():
    suite = unittest.TestLoader().loadTestsFromTestCase(testLibrsync)
    return suite

if __name__ == '__main__':
    runner = unittest.TextTestRunner()
    loader = unittest.TestLoader()
    results = unittest.TestResult()
    suite = SuiteRB()
    results = runner.run(suite)
